import pylab
import numpy as np
import ahkab
cir = ahkab.Circuit('Test FOUR and FFT')
mys = ahkab.time_functions.sin(vo=0, va=1, freq=10e3)
cir.add_resistor('R1', 'n1', cir.gnd, 1e3)
cir.add_vsource('V1', 'n1', cir.gnd, 1, function=mys)
tr = ahkab.new_tran(0, 1e-3, 1e-5, x0=None)
r = ahkab.run(cir, tr)['tran']

pylab.figure()
pylab.title('Comparison of different windowing')
for w in (ahkab.options.RECT_WINDOW, ahkab.options.BART_WINDOW,
          ahkab.options.HANN_WINDOW, ahkab.options.HAMM_WINDOW,
          ahkab.options.BLACK_WINDOW, ahkab.options.HARRIS_WINDOW,
          ahkab.options.KAISER_WINDOW):
    fsp1, Fsp1, THDsp = ahkab.fourier.spicefft('vn1', r, window=w)
    pylab.plot(fsp1, 20*np.log10(abs(Fsp1)),
               label=ahkab.options.WINDOWS_NAMES[w])
pylab.xlabel('Frequency [Hz]'); pylab.ylabel('Magnitude [dB]')
pylab.xlim((0, 100000))
pylab.legend()