import math
import numpy as np
import pylab
import ahkab
cir = ahkab.Circuit('Test custom time functions')
cir.add_resistor('R1', 'n1', cir.gnd, 1e3)
mys = lambda t: 1 if not t else math.sin(math.pi*1e4*t)/(math.pi*1e4*t)
cir.add_vsource('V1', 'n1', cir.gnd, 1, function=mys)
tr = ahkab.new_tran(0, 1e-3, 1e-5, x0=None)
r = ahkab.run(cir, tr)['tran']
t = r.get_x()
pylab.hold(True)
pylab.plot(t, r['vn1'], 'o', ms=3, label='V(n1) (simulation)')
npsin1k = np.frompyfunc(mys, 1, 1)
pylab.plot(t, npsin1k(t), label='sinc(ft) (theory)')
pylab.legend()
pylab.xlabel('t [s]')
pylab.ylabel('Voltage [V]')